// gshhs_color.c

#include "gshhs_win.h"

void Get_Pixel_Color( PGSINFO pgsi, BYTE cb, PBYTE pind,
                     PBYTE pr, PBYTE pg, PBYTE pb,
                     int nBPP )
{
   int ind = WHITE_IND;
   BYTE r = 255;
   BYTE g = 255;
   BYTE b = 255;
   switch(nBPP)
   {
   case 8:
      *pind = cb;
      break;
   case 4:
   case 24:
      switch(cb)
      {
      case BMC_BLACK:
         r = 0;
         g = 0;
         b = 0;
         ind = BLACK_IND;
         break;
      case BMC_GRAY:
         r = 190;
         g = 190;
         b = 190;
         ind = GRAY_IND;   // set GRAY
         break;
      case BMC_RED:
         r = 255;
         g = 0;
         b = 0;
         ind = RED_IND;    // set RED
         break;
      case BMC_BLUE:
         r = 0;
         g = 0;
         b = 255;
         ind = BLUE_IND;
         break;
      case BMC_GREEN:
         r = 0;
         g = 255;
         b = 0;
         ind = GREEN_IND;
         break;
      case BMC_BROWN:
         r = 0x8b;
         g = 0x45;
         b = 0x13;
         ind = BROWN_IND;
         break;
      case BMC_MAGENTA:
         r = 0x8B;
         g = 0x00;
         b = 0x8B;
         ind = MAGENTA_IND;
         break;
      case BMC_GOLD:
         r = 0xFF;
         g = 0xD7;
         b = 0x00;
         ind = GOLD_IND;
         break;
      case BMC_TEAL:
         r = 0x00;
         g = 0x80;
         b = 0x80;
         ind = TEAL_IND;
         break;
      case BMC_AQUA:
         r = 0x00;
         g = 0xFF;
         b = 0xFF;
         ind = AQUA_IND;
         break;
      case BMC_YELLOW:
         r = 0xFF;
         g = 0xFF;
         b = 0x00;
         ind = YELLOW_IND;
         break;
      case BMC_FUCHIA:
         r = 0xFF;
         g = 0x00;
         b = 0xFF;
         ind = FUCHIA_IND;
         break;
      case BMC_OLIVE:
         r = 0x80;
         g = 0x80;
         b = 0x00;
         ind = OLIVE_IND;
         break;
      case BMC_MAROON:
         r = 0x80;
         g = 0x00;
         b = 0x20;
         ind = MAROON_IND;
         break;
      case BMC_NAVY:
         r = 0x00;
         g = 0x20;
         b = 0x80;
         ind = NAVY_IND;
         break;
      }
      break;
   }
   *pind = ind;
   *pr = r;
   *pg = g;
   *pb = b;
}

char * Get_Color_Stg( BYTE cb )
{
   switch(cb)
   {
   case BMC_BLACK: return "BMC_BLACK";
   case BMC_GRAY:  return "BMC_GRAY";
   case BMC_RED:   return "BMC_RED";
   case BMC_BLUE:  return "BMC_BLUE";
   case BMC_GREEN: return "BMC_GREEN";
   case BMC_BROWN: return "BMC_BROWN";
   case BMC_MAGENTA: return "BMC_MAGENTA";
   case BMC_GOLD:  return "BMC_GOLD";
   case BMC_TEAL:  return "BMC_TEAL";
   case BMC_AQUA:  return "BMC_AQUA";
   case BMC_YELLOW: return "BMC_YELLOW";
   case BMC_FUCHIA: return "BMC_FUCHIA";
   case BMC_OLIVE: return "BMC_OLIVE";
   case BMC_MAROON: return "BMC_MAROON";
   case BMC_NAVY:  return "BMC_NAVY";
   }
   return "OUT_OF_RANGE";
}

void Set_Next_Color( PGSINFO pgsi )
{
   BYTE b = pgsi->def_bmc; 
   switch(b)
   {
   case BMC_BLACK:
      pgsi->def_bmc = BMC_BLUE;
      break;
   case BMC_BLUE:
      pgsi->def_bmc = BMC_BROWN;
      break;
   case BMC_BROWN:
      pgsi->def_bmc = BMC_BLACK;
      break;
   }
   pgsi->overwrite = 0; // clear the OVERWRITE flag
}

#define  SET_INDEX(i,r,g,b) prq[i].rgbRed = r; prq[i].rgbGreen = g; prq[i].rgbBlue = b

void Set_BMP_Color_Index( RGBQUAD * prq )
{
   // #define  WHITE_IND      0
   prq[WHITE_IND].rgbBlue  = 0xff;
   prq[WHITE_IND].rgbGreen = 0xff;
   prq[WHITE_IND].rgbRed   = 0xff;

   prq[BLACK_IND].rgbBlue  = 0;
   prq[BLACK_IND].rgbGreen = 0;
   prq[BLACK_IND].rgbRed   = 0;

   prq[GRAY_IND].rgbBlue  = 190;
   prq[GRAY_IND].rgbGreen = 190;
   prq[GRAY_IND].rgbRed   = 190;

   prq[BLUE_IND].rgbBlue  = 0xff;
   prq[BLUE_IND].rgbGreen = 0;
   prq[BLUE_IND].rgbRed   = 0;

   prq[RED_IND].rgbBlue  = 0;
   prq[RED_IND].rgbGreen = 0;
   prq[RED_IND].rgbRed   = 0xff;

   prq[GREEN_IND].rgbBlue  = 0;
   prq[GREEN_IND].rgbGreen = 0xff;
   prq[GREEN_IND].rgbRed   = 0;

   prq[BROWN_IND].rgbBlue  = 0x13;
   prq[BROWN_IND].rgbGreen = 0x45;
   prq[BROWN_IND].rgbRed   = 0x8b;

   SET_INDEX(MAGENTA_IND, 0x8B, 0x00, 0x8B);
   SET_INDEX(GOLD_IND, 0xFF, 0xD7, 0x00);
   SET_INDEX(TEAL_IND, 0x00, 0x80, 0x80);
   SET_INDEX(AQUA_IND, 0x00, 0xFF, 0xFF);
   SET_INDEX(YELLOW_IND, 0xFF, 0xFF, 0x00);
   SET_INDEX(FUCHIA_IND, 0xFF, 0x00, 0xFF);
   SET_INDEX(OLIVE_IND, 0x80, 0x80, 0x00);
   SET_INDEX(MAROON_IND, 0x80, 0x00, 0x20);
   SET_INDEX(NAVY_IND, 0x00, 0x20, 0x80);
}

#define SET_PAL(i, r, g, b ) ppal[i].rgbRed = r; ppal[i].rgbGreen = g; ppal[i].rgbBlue = b

void Set_BMP_Color( RGBQUAD * ppal )
{
   ppal[BMC_WHITE].rgbBlue  = 255;
   ppal[BMC_WHITE].rgbGreen = 255;
   ppal[BMC_WHITE].rgbRed   = 255;

   ppal[BMC_BLACK].rgbBlue  = 0;
   ppal[BMC_BLACK].rgbGreen = 0;
   ppal[BMC_BLACK].rgbRed   = 0;

   ppal[BMC_GRAY].rgbBlue  = 190;
   ppal[BMC_GRAY].rgbGreen = 190;
   ppal[BMC_GRAY].rgbRed   = 190;

   ppal[BMC_RED].rgbBlue  = 0;
   ppal[BMC_RED].rgbGreen = 0;
   ppal[BMC_RED].rgbRed   = 255;

   ppal[BMC_BLUE].rgbBlue  = 255;
   ppal[BMC_BLUE].rgbGreen = 0;
   ppal[BMC_BLUE].rgbRed   = 0;

   ppal[BMC_GREEN].rgbBlue  = 0;
   ppal[BMC_GREEN].rgbGreen = 255;
   ppal[BMC_GREEN].rgbRed   = 0;

   ppal[BMC_BROWN].rgbBlue  = 0x13;
   ppal[BMC_BROWN].rgbGreen = 0x45;
   ppal[BMC_BROWN].rgbRed   = 0x8b;

   SET_PAL(BMC_MAGENTA, 0x8B, 0x00, 0x8B);
   SET_PAL(BMC_GOLD,    0xFF, 0xD7, 0x00);
   SET_PAL(BMC_TEAL,    0x00, 0x80, 0x80);
   SET_PAL(BMC_AQUA,    0x00, 0xFF, 0xFF);
   SET_PAL(BMC_YELLOW,  0xFF, 0xFF, 0x00);
   SET_PAL(BMC_FUCHIA,  0xFF, 0x00, 0xFF);
   SET_PAL(BMC_OLIVE,   0x80, 0x80, 0x00);
   SET_PAL(BMC_MAROON,  0x80, 0x00, 0x20);
   SET_PAL(BMC_NAVY,    0x00, 0x20, 0x80);

}

void Set_BMP_1BPP( RGBQUAD * prq ) // in gshhs_color.c
{
   prq[0].rgbBlue     = 255;
   prq[0].rgbGreen    = 255;
   prq[0].rgbRed      = 255;
   prq[0].rgbReserved = 0;
   prq[1].rgbBlue     = 0;
   prq[1].rgbGreen    = 0;
   prq[1].rgbRed      = 0;
   prq[1].rgbReserved = 0;
}

void Set_BMP_4BPP( RGBQUAD * prq )
{
   int i;
   BYTE s;
   BYTE sc = 17;
   for( i = 0; i < 16; i++ )
   {
      s = (sc * (15 - i));
      prq[i].rgbBlue     = s;
      prq[i].rgbGreen    = s;
      prq[i].rgbRed      = s;
      prq[i].rgbReserved = 0;
   }

   Set_BMP_Color_Index( prq );
}

void Set_BMP_8BPP( RGBQUAD * ppal )
{
   Set_BMP_Color( ppal );
}


// eof - gshhs_color.c
