// nav_dat.cxx

//#include "aptdat.h"
#include <string>
#include <iostream>
#include "gshhs_win.h"
#include "zlib.h"

#ifndef  NO_ADD_FG_DATA

using namespace std;

/* ---------------------------------------
sample lines 
I
810 Version - DAFIF data cycle 2007.09, build 20070106, metadata NavXP810.  Copyright  2007, Robin A. Peel (robin@xsquawkbox.net).   This data is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.  You should have received a copy of the GNU General Public License along with this program ("AptNavGNULicence.txt"); if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.  This product was developed using DAFIF (the Defense Aeronautical Flight Information File), a product of the US National Imagery and Mapping Agency (NIMA). NIMA requires the following warranty statements:  (A) Under 10 U.S.C. 456, no civil action may be brought against the United States on the basis of the content of a navigational aid prepared or disseminated by either the former Defense Mapping Agency (DMA) or the National Imagery and Mapping Agency (NIMA).  (B) The DAFIF product is provided "as is," and no warranty, express or implied, including, but not limited to the implied warranties of merchantability and fitness for particular purpose or arising by statute or otherwise in law or from a course of dealing or usage in trade, is made by NIMA as to the accuracy and functioning of the product. : Neither NIMA nor its personnel will be liable for any claims, losses, or damages arising from or connected with the use of this product.  The user agrees to hold harmless the United States National Imagery and Mapping Agency.  The user's sole and exclusive remedy is to stop using the DAFIF product.

2  38.08776900 -077.32491900    284   396  25    0.0 APH  A P HILL NDB
2  57.08382000  009.68009300      0   398  25    0.0 GL   AALBORG NDB
3  57.10371900  009.99557800     57 11670 100    1.0 AAL  AALBORG VOR-DME
3  49.22907200  007.41789200   1177 11480  60    0.0 ZWN  ZWEIBRUCKEN VOR-DME
4  39.98091100 -075.87781400    660 10850  18     281.662 IMQS 40N  29  ILS-cat-I
4 -09.45892200  147.23122500    128 11010  18     148.638 IWG  AYPY 14L ILS-cat-I
5  67.01850600 -050.68207200    165 10955  18      61.600 ISF  BGSF 10  LOC
5  65.63722200 -018.02611100     46 10890  18      22.392 IAR  BIAR 01  LOC
6  39.97729400 -075.86027500    655 10850  10  300281.662 IMQS 40N  29  GS
6 -09.43270300  147.21644400    128 11010  10  302148.638 IWG  AYPY 14L GS
6  42.88151400  129.43913900    624 10870  10  300081.620 IJA  ZYYJ 09  GS
7  39.96071900 -075.75077800    660     0   0     281.662 ---- 40N  29  OM
7 -09.37615000  147.17686700    146     0   0     148.638 ---- AYPY 14L OM
7  41.69657200  123.57017800    198     0   0     224.655 ---- ZYTX 24  OM
8 -09.42187500  147.20833100     91     0   0     148.638 ---- AYPY 14L MM
8 -09.46105000  147.23254400    146     0   0     328.625 ---- AYPY 32R MM
9  65.60944400 -018.05222200     32     0   0      21.368 ---- BIAR 01  IM
9  08.42532000  004.47559800   1126     0   0      47.638 ---- DNIL 05  IM
12 -09.43270300  147.21644400    128 11010  18       0.200 IWG  AYPY 14L DME-ILS
12 -09.44922200  147.22658900    103 10950  18       0.200 IBB  AYPY 32R DME-ILS
12  49.22907200  007.41789200   1177 11480  60    0.0 ZWN  ZWEIBRUCKEN VOR-DME
13  57.10393300  009.99280800     57 11670 199    0.0 AAL  AALBORG TACAN
13  68.71941900 -052.79275300    172 10875  25    0.0 AS   AASIAAT DME
13  49.20933100  007.39577800   1201 10910  25    0.0 ZND  ZWEIBRUCKEN DME
99

FG record
class FGNavRecord : public SGReferenced {

    int type;
    SGGeod pos;                // location in geodetic coords (degrees)
    SGVec3d cart;              // location in cartesian coords (earth centered)
    int freq;
    int range;
    double multiuse;            // can be slaved variation of VOR
                                // (degrees) or localizer heading
                                // (degrees) or dme bias (nm)

    string ident;		// navaid ident
    string name;                // verbose name in nav database
    string apt_id;              // corresponding airport id


    bool serviceable;		// for failure modeling
    string trans_ident;         // for failure modeling

   ------------------------------------------ */

static char * tokens[FG_MAX_TOKENS];
static int tok_count;

//     in >> n.type;
// if ( n.type == 99 ) {
//        return in >> skipeol;
//    }
//    double lat, lon, elev_ft;
//    in >> lat >> lon >> elev_ft >> n.freq >> n.range >> n.multiuse
//       >> n.ident;
//    n.pos.setLatitudeDeg(lat);
//    n.pos.setLongitudeDeg(lon);
//    n.pos.setElevationFt(elev_ft);
//    getline( in, n.name );

LE sNavItems = { &sNavItems, &sNavItems };

PLE Get_Nav_List( void )
{
   return &sNavItems;
}

void Del_Nav_List( void )
{
   PLE ph = Get_Nav_List();
   KillLList(ph);
}

FG_NAV_TYPES Get_Nav_Type( int type )
{
   switch(type) {
   case 2: return(FG_NAV_NDB);
   case 3: return(FG_NAV_VOR);
   case 4: return(FG_NAV_ILS);
   }
   return FG_NAV_ANY;
}

PNAVITEM Add_Nav_List( PLE ph, int type, double lat, double lon, int elev,
                      int freq, int range, double users,
                      const char * pid, const char * pname )
{
   PNAVITEM pni = (PNAVITEM)MALLOC( sizeof(NAVITEM) );
   CHKMEM(pni,sizeof(NAVITEM));
   pni->type = type;
   pni->fgtype = Get_Nav_Type(type);
   pni->lat  = lat;
   pni->lon  = lon;
   pni->elev_ft = elev;
   pni->freq = freq;
   pni->range = range;
   pni->multi = users;
   if( strlen(pid) < MX_NAV_ID ) {
      strcpy(pni->ident, pid);
   } else {
      strncpy(pni->ident, pid, MX_NAV_ID);
      pni->ident[MX_NAV_ID] = 0;
   }
   while(*pname && (*pname <= ' '))
      pname++;

   pni->aptid[0] = 0;
   if ( type >= 4 && type <= 9 ) {
       // these types are always associated with an airport id
       //string::size_type pos = n.name.find(" ");
       //n.apt_id = n.name.substr(0, pos);
       const char * p = strchr(pname, ' ');
       if(p) {
          int dif = (int)(p - pname);
          strncpy(pni->aptid, pname, dif);
          pni->aptid[dif] = 0;
       }
    }

   if( strlen(pname) < MX_NAV_NAME ) {
      strcpy(pni->name, pname);
   } else {
      strncpy( pni->name, pname, MX_NAV_NAME );
      pni->name[MX_NAV_NAME] = 0;
   }
    // silently multiply adf frequencies by 100 so that adf
    // vs. nav/loc frequency lookups can use the same code.
    if ( pni->type == 2 ) {
        pni->freq *= 100;
    }
    // Ranges are included with the latest data format, no need to
    // assign our own defaults, unless the range is not set for some
    // reason.
    if ( pni->range < 1 ) {
        // assign default ranges
        if ( pni->type == 2 || pni->type == 3 ) {
            pni->range = FG_NAV_DEFAULT_RANGE;
        } else if ( pni->type == 4 || pni->type == 5 || pni->type == 6 ) {
            pni->range = FG_LOC_DEFAULT_RANGE;
        } else if ( pni->type == 12 ) {
            pni->range = FG_DME_DEFAULT_RANGE;
        } else {
            pni->range = FG_LOC_DEFAULT_RANGE;
        }
    }

   InsertTailList(ph, (PLE)pni);
   return pni;
}

PNAVITEM Add_Nav_Item( int type, double lat, double lon, int elev,
                      int freq, int range, double users,
                      const char * pid, const char * pname )
{
   PLE ph = Get_Nav_List();
   return Add_Nav_List( ph, type, lat, lon, elev, freq, range, users, pid, pname );
}

static char buf[FG_MX_BUFF+8];

int Load_Nav_File( char * pfile )
{
   int   added_count = 0;
   unsigned int line_num = 0;
   gzFile gzf = gzopen(pfile, "rb");
   if( gzf ) {
      char * pb = buf;
      int    line_num = 0;
      char * cp;
      string name = "";
      string line = "";
      // skip first two lines
      cp = gzgets( gzf, pb, FG_MX_BUFF ); // int rd = gzread( gzf, buf, 2048 );
      cp = gzgets( gzf, pb, FG_MX_BUFF ); // int rd = gzread( gzf, buf, 2048 );
      cp = gzgets( gzf, pb, FG_MX_BUFF ); // int rd = gzread( gzf, buf, 2048 );
      do {
         size_t len = strlen(buf);
         while(len--) {
            if( buf[len] > ' ' )
               break;
            buf[len] = 0;
         }
         cp = buf;
         len = strlen(cp);
         line_num++;
         tok_count = 0;
         tokens[tok_count++] = pb;
         cp = pb;
         if( len > 0 ) {
            line = pb;
            while( *cp ) {
               while( *cp > ' ' ) cp++;
               if( *cp ) {
                  *cp = 0;
                  cp++;
                  while( *cp && (*cp <= ' ') ) cp++;
                  tokens[tok_count++] = cp;
                  if(tok_count >= FG_MAX_TOKENS )
                     break;
               }
            }
            int type = atoi( tokens[0] );
            if( type >= 99 ) {
               if( iVerbal >= 2 ) {
                  sprtf( "End of list reached ...\n" );
               }
               break;
            }
            if( tok_count > 8 ) {
               // in >> lat >> lon >> elev_ft >> n.freq >> n.range >> n.multiuse
               //       >> n.ident; getline( in, n.name );
               double lat = atof( tokens[1] );
               double lon = atof( tokens[2] );
               int elev = atoi( tokens[3] );
               int freq = atoi( tokens[4] );
               int range = atoi( tokens[5] );
               double users = atof( tokens[6] );
               string id = tokens[7];
               name = "";
               for ( int i = 8; i < tok_count - 1; ++i ) {
                  name += tokens[i];
                  name += " ";
               }
               name += tokens[tok_count - 1];
               Add_Nav_Item( type, lat, lon, elev,
                      freq, range, users,
                      id.c_str(), name.c_str() );
               added_count++;
            } else {
               sprtf( "WARNING: %d line [%s] NON CONFORMING! Ignored!!\n",
                  line_num, line.c_str() );
            }
         }
      } while (( cp = gzgets( gzf, pb, FG_MX_BUFF ) ) != NULL );
      gzclose(gzf);
      if( iVerbal >= 2 ) {
         sprtf( "Added %d NAV items to list ...\n", added_count );
      }
   } else {
      sprtf( "WARNING: Failed to open %s file ...\n", pfile );
   }
   return added_count;
}

int Get_Nav_in_Bounds( double n, double s, double e, double w, PLE ph )
{
   int   found = 0;
   PLE   phn = Get_Nav_List();
   PLE   pn;
   double lat, lon;
   PNAVITEM pni, pni2;

   Traverse_List( phn, pn )
   {
      pni = (PNAVITEM)pn;
      lat = pni->lat;
      lon = pni->lon;
      if(( lat <= n )&&
         ( lat >= s )&&
         ( lon <= e )&&
         ( lon >= w )) {
         found++;
         pni2 = (PNAVITEM)MALLOC(sizeof(NAVITEM));
         CHKMEM(pni2,sizeof(NAVITEM));
         memcpy(pni2, pni, sizeof(NAVITEM));
         InsertTailList(ph, (PLE)pni2);
      }
   }
   return found;
}

#endif // #ifndef  NO_ADD_FG_DATA

// eof - nav_dat.cxx
